# ListObjectsAsync

## Обзор
ListObjectsAsync - это асинхронный инструмент для перечисления объектов в AWS S3 бакете.

Этот инструмент использует библиотеку aiobotocore для обеспечения эффективного, неблокирующего доступа к вашим
данным S3, поддерживая рекурсивное перемещение по директориям с контролем глубины.

## Возможности

- Асинхронные операции: использует asyncio для неблокирующих операций ввода-вывода.
- Постраничные результаты: обрабатывает пагинацию S3 внутренне, чтобы обеспечить эффективное перемещение по длинным спискам объектов S3.
- Рекурсивный обход: поддерживает рекурсивное перечисление объектов с контролем глубины.
- Повторы: использует стратегии повторных попыток AWS.

## Использование

```python
--8<-- "list.py"
```
Вы можете контролировать глубину рекурсии, указывая параметр max_depth, по умолчанию глубина не ограничена.


### Детали реализации

[Группировка префиксов][async_s3.group_by_prefix.group_by_prefix] используется для сокращения количества API вызовов.
Конечно, это не всегда возможно, но в худшем случае это около 50 групп по одному символу для всех возможных символов в ключе объекта. 

И в большинстве случаев их намного меньше, например:

```
folder/0123.jpg
folder/0124.jpg
folder/0125.jpg
..
folder/9926.jpg
```

мы можем сжать до десяти групп:

```
folder/0
folder/1
...
folder/9
```

[ListObjectsAsync][async_s3]